#!/bin/sh

### Parameters
THEPEG_VERSION=1.9.0a
GSL_VERSION=1.10
BOOST_VERSION=1.55.0_python2.7
FASTJET_VERSION=3.0.6
HERWIGPP_VERSION=2.7.0a

[ ! "Darwin" = $(uname -s) ] && source /afs/cern.ch/sw/lcg/contrib/gcc/4.8.1/x86_64-slc6-gcc48-opt/bin/../setup.sh
### End parameters

scriptdir=$(cd "$(dirname -- "${BASH_SOURCE[0]}")" && pwd)
LCGDIR=$(cd $scriptdir;pwd | awk -F'/MCGenerators' '{print $1}')
MCGEN=$LCGDIR/$(cd $scriptdir;pwd | awk -F"$LCGDIR" '{print $2}' | awk -F'/' '{print $2}')
PLATFORM=$(basename $scriptdir)

LHAPDF_VERSION=$(ls -t $MCGEN/lhapdf | head -1 )
LHAPDF_HOME=/afs/cern.ch/sw/lcg/external/lhapdfsets/$LHAPDF_VERSION
HEPMC_VERSION=$(ls -t $LCGDIR/HepMC | head -1)
HEPMC_HOME=$LCGDIR/HepMC/$HEPMC_VERSION/$PLATFORM
HERWIGPP_HOME=$MCGEN/herwig++/$HERWIGPP_VERSION/$PLATFORM
THEPEG_HOME=$MCGEN/thepeg/$THEPEG_VERSION/$PLATFORM
GSL_HOME=$LCGDIR/GSL/$GSL_VERSION/$PLATFORM
BOOST_HOME=$LCGDIR/Boost/$BOOST_VERSION/$PLATFORM
FASTJET_HOME=$LCGDIR/fastjet/$FASTJET_VERSION/$PLATFORM

export PATH=$HERWIGPP_HOME/bin:$PATH
export LD_LIBRARY_PATH=${THEPEG_HOME}/lib/ThePEG:${GSL_HOME}/lib:${BOOST_HOME}/lib:${HERWIGPP_HOME}/lib/Herwig++:${FASTJET_HOME}/lib:${THEPEG_HOME}/lib/ThePEG:${GSL_HOME}/lib:${BOOST_HOME}/lib:${FASTJET_HOME}/lib:$HEPMC_HOME/lib:$LD_LIBRARY_PATH
export REPO=${HERWIGPP_HOME}/share/Herwig++/HerwigDefaults.rpo
export LHAPATH=$LHAPDF_HOME/share/PDFsets
[ "Darwin" = $(uname -s) ] && export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
